Index: squid/src/HintCache.c
diff -u /dev/null squid/src/HintCache.c:1.1.2.2
--- /dev/null	Mon Jan 26 04:57:38 2004
+++ squid/src/HintCache.c	Mon May 20 19:46:41 2002
@@ -0,0 +1,460 @@
+/*
+ * $Date: 2004/08/17 20:55:13 $ $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * AUTHOR: Mike Dahlin, UT Austin, 1998
+ * DEBUG: section 84    Hint cache to Squid interface.
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+/*
+ *------------------------------------------------------------------
+ * LESS Group 
+ * Computer Sciences Department 
+ * University of Texas at Austin
+ *
+ * HintCache.c --- High-level interface to hint cache.
+ *------------------------------------------------------------------
+ */
+
+#include "squid.h"
+
+static EVH hintCacheTimer;	/* timeout to flush StoreEntries */
+
+#define HINT_CACHE_DEBUG 84
+
+/*
+ * Globals
+ */
+#if USE_DYNAMIC_HIERARCHY
+HintCacheNet *parentOutgoingA = NULL;
+HintCacheNet *childrenOutgoingA = NULL;
+HintCacheNet *neighborsOutgoing = NULL;
+#endif
+HintCacheDisk *hcDisk = NULL;
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheInit --
+ *
+ *          description.
+ *
+ * Results:
+ *      Return nonzero on error.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+int
+hintCacheInit()
+{
+    peer *e;
+#if USE_DYNAMIC_HIERARCHY
+    int ii;
+#endif
+
+    hcDisk = (HintCacheDisk *) xmalloc(sizeof(HintCacheDisk));
+    assert(hcDisk);
+    hintCacheDiskInit(hcDisk, Config.Hints.cache_file);
+
+#if USE_DYNAMIC_HIERARCHY
+    /*
+     * Three sets of network buffers. Children and parents
+     * are the children and parents as determined by the
+     * dynamic hierarchy algorithm (HCHier.h). Neighbors
+     * are static squid neighbors (neighbors.h). The
+     * static neighbors are used to bootstrap the
+     * dynamic algorithm.
+     */
+    neighborsOutgoing = (HintCacheNet *) xmalloc(sizeof(HintCacheNet));
+    assert(neighborsOutgoing);
+    hintCacheNetInit(neighborsOutgoing);
+    hintCacheHierInit();
+
+    childrenOutgoingA =
+	(HintCacheNet *) xmalloc(sizeof(HintCacheNet) *
+	hintCacheHier_NChildrenQs());
+    assert(childrenOutgoingA);
+    for (ii = 0; ii < hintCacheHierNChildrenQs(); ii++) {
+	hintCacheNet_Init(&childrenOutgoingA[ii]);
+    }
+    parentOutgoingA =
+	(HintCacheNet *) xmalloc(sizeof(HintCacheNet) *
+	hintCacheHier_NParentQs());
+    assert(parentOutgoingA);
+    for (ii = 0; ii < hintCacheHierNParentQs(); ii++) {
+	hintCacheNetInit(&parentOutgoingA[ii]);
+    }
+#else
+    for (e = getFirstPeer(); e; e = getNextPeer(e))
+	hintCacheNetInit(&e->hcoutq);
+#endif
+
+    /* Start hint timer */
+    eventAdd("hint timer", hintCacheTimer, NULL,
+	(double) (squid_random() % Config.Hints.intvl), 1);
+
+    return 0;
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheDestroy --
+ *
+ *          Shut down.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheDestroy()
+{
+#if USE_DYNAMIC_HIERARCHY
+    int ii;
+
+    for (ii = 0; ii < hintCacheHier_NChildrenQs(); ii++) {
+	hintCacheNetDestroy(&childrenOutgoingA[ii]);
+    }
+    xfree(childrenOutgoingA);
+    childrenOutgoingA = NULL;
+    for (ii = 0; ii < hintCacheHier_NParentQs(); ii++) {
+	hintCacheNetDestroy(&parentOutgoingA[ii]);
+    }
+    xfree(parentOutgoingA);
+    parentOutgoingA = NULL;
+    hintCacheNetDestroy(neighborsOutgoing);
+    xfree(neighborsOutgoing);
+    neighborsOutgoing = NULL;
+#endif
+
+    hintCacheHierDestroy();
+
+    hintCacheDiskClose(hcDisk);
+    xfree(hcDisk);
+    hcDisk = NULL;
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheCreate --
+ *
+ *          Create a NEW disk cache (obliterating the one
+ *          already on disk, if any). Then do normal initialization.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheCreate(void)
+{
+    if (access(Config.Hints.cache_file, R_OK | W_OK) == -1)
+	hintCacheDiskCreateFile(Config.Hints.cache_file, Config.Hints.size,
+	    Config.Hints.assoc);
+
+    hintCacheInit();
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheinformLocalCopy --
+ *
+ *          description.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheInformLocalCopy(StoreEntry * entry)
+{
+    char *url = entry->mem_obj->url;
+    struct sockaddr_in *me;
+    HintCacheEntry myentry;
+    URLKey *key;
+    HintCacheUpdate update;
+
+    debug(HINT_CACHE_DEBUG, 5) ("hintCacheinformLocalCopy: got %s\n",
+				url);
+
+    if (!HINT_CACHE_ACTIVE()) {
+	/* Hint cache is inoperative.  Nothing to do. */
+	return;
+    }
+
+    if (strstr(url, "//updates"))
+	/* Routes handle their own updates */
+	return;
+
+    me = &Config.Sockaddr.http->s;
+
+    /* Prepare data structures */
+    key = HINT_CACHE_KEY(entry);
+    hintCacheEntryInit(&myentry, *key, me, entry->lastmod);
+    hintCacheUpdateInit(&update, HC_InformToParent, &myentry, 0);
+
+    /*
+     * Update local and remote hint caches.
+     */
+    hintCachePropHandleInformToParent(&update, me, 1);
+    update.action = HC_InformToChild;
+    hintCachePropHandleInformToChild(&update, me, 1);
+}
+
+void
+hintCacheInvalLocalCopy(StoreEntry * entry)
+{
+    struct sockaddr_in *me;
+    HintCacheEntry myentry;
+    HintCacheUpdate update;
+
+    if (!HINT_CACHE_ACTIVE()) {
+	/* Hint cache is inoperative.  Nothing to do. */
+	return;
+    }
+
+    me = &Config.Sockaddr.http->s;
+
+    /* Prepare data structures */
+    hintCacheEntryInit(&myentry, *HINT_CACHE_KEY(entry),
+		       me, entry->lastmod);
+    hintCacheUpdateInit(&update, HC_InvalToParent, &myentry, 0);
+
+    /*
+     * Update local and remote hint caches.
+     */
+    hintCacheHandleInvalToParent(&update, me, 1);
+    update.action = HC_InvalToChild;
+    hintCachePropHandleInvalToChild(&update, me, 1);
+
+    debug(HINT_CACHE_DEBUG, 5) ("hintCacheinvalLocalCopy: lost 0x%qx\n",
+				((URLKey *) &entry->hchash.key)->key);
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCachefindNearest --
+ *
+ *          Find the nearest copy of the specified URL.
+ *          Return a copy of the location in *saddr.
+ *          Return the saddr pointer if we found a copy
+ *          or return NULL if no copy found.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------3.24.1998-----------
+ */
+struct sockaddr_in *
+hintCacheFindNearest(StoreEntry *entry, struct sockaddr_in *saddr)
+{
+    const struct sockaddr_in *me;
+    URLKey *urlKey;
+    HintCacheEntry nearest;
+    int found;
+
+    if (!HINT_CACHE_ACTIVE()) {
+	/* Hint cache is inoperative.  Nothing to do. */
+	return (NULL);
+    }
+
+    urlKey = HINT_CACHE_KEY(entry);
+    found = hintCacheDiskFindNearest(hcDisk, *urlKey, &nearest);
+    if (!found)
+	return NULL;
+
+    saddr->sin_family = AF_INET;
+    saddr->sin_port = nearest.port;
+    saddr->sin_addr = nearest.ipaddr;
+
+    /* Never return ourselves. */
+    me = &Config.Sockaddr.http->s;
+    if (saddr->sin_port == me->sin_port) {
+	if (saddr->sin_addr.s_addr == me->sin_addr.s_addr)
+	    return NULL;
+	if (saddr->sin_addr.s_addr == 0x7f000000)
+	    return NULL;
+    }
+#if 0				/* Fixed? */
+    /* XXX - shouldn't be needed, but is - noted in BUGS */
+    /* Swap bytes to host format. */
+    saddr->sin_addr.s_addr = ntohl(saddr->sin_addr.s_addr);
+    saddr->sin_port = ntohs(saddr->sin_port);
+#endif
+    debug(HINT_CACHE_DEBUG, 5) ("hintCachefindNearest: %s is at <%s,%d>\n",
+	entry->mem_obj->url, inet_ntoa(saddr->sin_addr), saddr->sin_port);
+    return (saddr);
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheTimer --
+ *
+ *          This gets called every so often. Its job is
+ *          to flush outgoing messages.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+static void
+hintCacheTimer(void *junk)
+{
+    struct sockaddr_in sin;
+#if USE_DYNAMIC_HIERARCHY
+    struct sockaddr_in *childSinA = NULL;
+    static int nextjoin = 0;
+    int nchildren, ichild;
+    int error;
+    int ii;
+#else
+    peer *e;
+#endif
+
+    /* Reload timer */
+    eventAdd("hint timer", hintCacheTimer, NULL,
+	(double) (squid_random() % Config.Hints.intvl), 1);
+
+#if USE_DYNAMIC_HIERARCHY
+    /* Process peers */
+    /* Send enqueued updates */
+    if (parentOutgoingA != NULL) {
+	for (ii = 0; ii < hintCacheHier_NParentQs(); ii++) {
+	    if (hintCacheNetBytesReady(&parentOutgoingA[ii]) >
+		sizeof(HintCacheNetHeader)) {
+		hintCacheNetComplete(&parentOutgoingA[ii]);
+		error = hintCacheHierGetParentAddr(ii, &sin);
+		debug(HINT_CACHE_DEBUG, 6)
+		    ("Sending %d bytes from parentOutgoing[%d] to %s %s\n",
+		    hintCacheNetbytesReady(&parentOutgoingA[ii]), ii,
+		    inet_ntoa(sin.sin_addr), error ? "ERROR" : "");
+		if (!error) {
+		    hintCacheNetSendTo(&parentOutgoingA[ii], &sin);
+		}
+		hintCacheNetDone(&parentOutgoingA[ii]);
+	    }
+	}
+    }
+    if (childrenOutgoingA != NULL) {
+	for (ii = 0; ii < hintCacheHierNChildrenQs(); ii++) {
+	    if (hintCacheNet_bytesReady(&childrenOutgoingA[ii]) >
+		sizeof(HintCacheNetHeader)) {
+		hintCacheNetComplete(&childrenOutgoingA[ii]);
+		nchildren = hintCacheHierGetChildAddrs(ii, &childSinA);
+		debug(HINT_CACHE_DEBUG, 6)
+		    ("Sending %d bytes to %d children from childrenOutgoing[%d]:",
+		    hintCacheNetBytesReady(&childrenOutgoingA[ii]), nchildren,
+		    ii);
+
+		for (ichild = 0; ichild < nchildren; ichild++) {
+		    debug(HINT_CACHE_DEBUG, 8) (" %s ",
+			inet_ntoa(childSinA[ichild].sin_addr));
+		    hintCacheNetSendTo(&childrenOutgoingA[ii],
+			&childSinA[ichild]);
+		}
+
+		hintCacheNetDone(&childrenOutgoingA[ii]);
+		xfree(childSinA);
+	    }
+	}
+    }
+#else
+    for (e = getFirstPeer(); e; e = getNextPeer(e)) {
+	if (hintCacheNetBytesReady(&e->hcoutq) > sizeof(HintCacheNetHeader)) {
+	    hintCacheNetComplete(&e->hcoutq);
+	    sin.sin_addr = e->in_addr.sin_addr;
+	    sin.sin_port = e->http_port;
+	    hintCacheNetSendTo(&e->hcoutq, &sin);
+	    hintCacheNetDone(&e->hcoutq);
+	}
+    }
+#endif /* USE_DYNAMIC_HIERARCHY */
+
+
+#if USE_DYNAMIC_HIERARCHY
+    /*
+     * Send out Joins once every few hours.
+     */
+    if (hintCacheNodelistMyStatus() == HC_Join) {
+	if (squid_curtime >= nextjoin) {
+	    hintCacheNodelistLocalJoin();
+	    nextjoin =
+		squid_curtime + (squid_random() % Config.Hints.join_intvl);
+	}
+    }
+#endif
+
+#ifdef DOTEST
+    if (0) {			/* XXX */
+	if (!hintCacheHierSelfTestDone) {
+	    hintCacheHierTestNetwork();
+	}
+    }
+#endif
+}
